 
DEFINE VARIABLE APIURI              AS CHARACTER                           NO-UNDO.
DEFINE VARIABLE jsonResponse        AS LONGCHAR                            NO-UNDO.
DEFINE VARIABLE bodyString          AS CHARACTER                           NO-UNDO. 
DEFINE VARIABLE httpRequestMessage  AS System.Net.Http.HttpRequestMessage  NO-UNDO. 
DEFINE VARIABLE httpClient          AS System.Net.Http.HttpClient          NO-UNDO.   
DEFINE VARIABLE httpResponseMessage AS System.Net.Http.HttpResponseMessage NO-UNDO.
 
/* Everyone logs in using the same URL (the response contains the instance URL) */
ASSIGN 
  APIURI = "https://test.salesforce.com/services/oauth2/token".
            
/* Build query parameters to pass in the body - JSON is NOT supported for the login request */        
bodyString = 
  "grant_type=password" +
  "&client_id=3MVG9Gmy2zmPB01o1KLKTRI6RE98Lni7V3nPSYnuFY5GyerhYqc4BdeKKU2P.S3Pbaa6rd8OCuODauwPZHjmB" +
  "&client_secret=351590979536293321" +
  "&username=gwinning@gmail.com.winningPUG" +
  "&password=" + "kayla305" + "kMkfhX2tyDzYaExtMBF98MsR".

/* create and configure the httpRequestMessage we are going to POST */
httpRequestMessage = NEW System.Net.Http.HttpRequestMessage().
httpRequestMessage:Method = System.Net.Http.HttpMethod:Post.
httpRequestMessage:RequestUri = NEW System.Uri(APIURI).
httpRequestMessage:Content =  NEW System.Net.Http.StringContent(bodyString).
httpRequestMessage:Content:Headers:ContentType = NEW System.Net.Http.Headers.MediaTypeHeaderValue("application/x-www-form-urlencoded").

/* create the httpClient object */ 
httpClient = NEW System.Net.Http.HttpClient().
/* Use SendAsync in a synchronous manner by directly accessing the result */
httpResponseMessage = httpClient:SendAsync(httpRequestMessage):Result. 
/* copy the JSON in the response into a longchar */
jsonResponse = httpResponseMessage:Content:ReadAsStringAsync():Result.

/* if you did everything correctly, you will get a 200 ("OK") response */
IF  httpResponseMessage:StatusCode:value__ <> 200 THEN 
DO:
  /* you did something wrong - the JSON returned will be the error */ 
  MESSAGE 
    STRING (jsonResponse) SKIP 
    httpResponseMessage:StatusCode:value__
    VIEW-AS ALERT-BOX.
  RETURN.
END.

MESSAGE STRING (jsonResponse)
  VIEW-AS ALERT-BOX.

DEFINE VARIABLE objectModelParser AS Progress.Json.ObjectModel.ObjectModelParser NO-UNDO.
DEFINE VARIABLE jsonObject        AS Progress.Json.ObjectModel.JsonObject        NO-UNDO.

objectModelParser = NEW Progress.Json.ObjectModel.ObjectModelParser().
jsonObject = CAST
  (objectModelParser:Parse(jsonResponse),
  Progress.Json.ObjectModel.JsonObject).

MESSAGE 
  "Server/Instance URL: "   jsonObject:GetCharacter("instance_url") SKIP 
  "-------------------" SKIP 
  "AccessToken:  "   jsonObject:GetCharacter("access_token") SKIP              
  VIEW-AS ALERT-BOX.
    
