DEFINE VARIABLE APIURI              AS CHARACTER                                   NO-UNDO. 
DEFINE VARIABLE sfdcREST            AS SFDC.SFDCREST                               NO-UNDO.
DEFINE VARIABLE httpClient          AS System.Net.Http.HttpClient                  NO-UNDO.   
DEFINE VARIABLE httpResponseMessage AS System.Net.Http.HttpResponseMessage         NO-UNDO.
DEFINE VARIABLE httpRequestMessage  AS System.Net.Http.HttpRequestMessage          NO-UNDO. 
DEFINE VARIABLE jsonResponse        AS LONGCHAR                                    NO-UNDO. 
DEFINE VARIABLE objectModelParser   AS Progress.Json.ObjectModel.ObjectModelParser NO-UNDO.
DEFINE VARIABLE jsonObject          AS Progress.Json.ObjectModel.JsonObject        NO-UNDO.
DEFINE VARIABLE startDateTimeString AS CHARACTER                                   NO-UNDO. 
DEFINE VARIABLE endDateTimeString   AS CHARACTER                                   NO-UNDO. 
DEFINE VARIABLE endDateTime         AS DATETIME                                    NO-UNDO. 
DEFINE VARIABLE beginDateTime       AS DATETIME                                    NO-UNDO. 

sfdcREST = NEW SFDC.SFDCREST().
sfdcREST:SFDCPasswordConnect().

/* We need a start and end time, URL encoded, in ISO format.  In your applicaiton, you 
   would go from the last time you got updates until NOW.  If you know of better way to
   build the endDateTimeString and startDateTimeString strings, email me!
     
   From the REST API Docs:
   Date/time (Coordinated Universal Time (UTC) time zone, not local timezone) of the 
   timespan for which to retrieve the data. The API ignores the seconds portion of the specified 
   dateTime value (for example, 12:30:15 is interpreted as 12:30:00 UTC). The date and time should 
   be provided in ISO 8601 format: YYYY-MM-DDThh:mm:ss+hh:mm. The date/time value for start must 
   chronologically precede end. This parameter should be URL-encoded     */
 
/* get right now and a day ago in the the rquired SFDC date-string format (UTC time) */
endDateTimeString = sfdcREST:SFDCUTCDateString(NOW).
startDateTimeSTring = sfdcREST:SFDCUTCDateString(ADD-INTERVAL (NOW, -1, 'days')).

APIURI = sfdcREST:ServerURL + "/services/data/v35.0/sobjects/account/updated/?start=" + startDateTimeString + "&end=" + endDateTimeString.

MESSAGE APIURI
  VIEW-AS ALERT-BOX.

httpRequestMessage = NEW System.Net.Http.HttpRequestMessage().
httpRequestMessage:Method = System.Net.Http.HttpMethod:Get.
httpRequestMessage:RequestUri = NEW System.Uri(APIURI).
httpRequestMessage:Headers:Add ("Authorization", "Bearer " + sfdcREST:AccessToken).

httpClient = NEW System.Net.Http.HttpClient().
/* Use SendAsync in a synchronous manner by directly accessing the result */
httpResponseMessage = httpClient:SendAsync(httpRequestMessage):Result.
jsonResponse = httpResponseMessage:Content:ReadAsStringAsync():RESULT NO-ERROR.

IF  httpResponseMessage:StatusCode:value__ <> 200 THEN 
DO:
  MESSAGE 
    STRING (jsonResponse) SKIP 
    httpResponseMessage:StatusCode:value__
    VIEW-AS ALERT-BOX.
  RETURN.
END.

MESSAGE 
  STRING (jsonResponse) SKIP VIEW-AS ALERT-BOX. 




    